#!/usr/bin/perl
+use FindBin;
+use lib "$FindBin::Bin";
use strict;
-my %preconfig;
-my %package;
-my %srcpackage;
-my %category;
-my %subdir;
-
-sub get_multiline {
- my $prefix = shift;
- my $str;
- while (<>) {
- last if /^@@/;
- s/^\s*//g;
- $str .= (($_ and $prefix) ? $prefix . $_ : $_);
- }
+use metadata;
+
+my %board;
- return $str;
+sub confstr($) {
+ my $conf = shift;
+ $conf =~ tr#/\.\-/#___#;
+ return $conf;
}
sub parse_target_metadata() {
- my ($target, @target, $profile);
- while (<>) {
+ my $file = shift @ARGV;
+ my ($target, @target, $profile);
+ open FILE, "<$file" or do {
+ warn "Can't open file '$file': $!\n";
+ return;
+ };
+ while (<FILE>) {
chomp;
/^Target:\s*(.+)\s*$/ and do {
- my $conf = $1;
- $conf =~ tr#/\.\-/#___#;
$target = {
id => $1,
- conf => $conf,
- profiles => []
+ conf => confstr($1),
+ profiles => [],
+ features => [],
+ depends => []
};
push @target, $target;
};
- /^Target-Board:\s*(.+)\s*$/ and $target->{board} = $1;
+ /^Target-Board:\s*(.+)\s*$/ and do {
+ $target->{board} = $1;
+ $target->{boardconf} = confstr($1);
+ };
/^Target-Kernel:\s*(\d+\.\d+)\s*$/ and $target->{kernel} = $1;
/^Target-Name:\s*(.+)\s*$/ and $target->{name} = $1;
/^Target-Path:\s*(.+)\s*$/ and $target->{path} = $1;
/^Target-Arch:\s*(.+)\s*$/ and $target->{arch} = $1;
/^Target-Features:\s*(.+)\s*$/ and $target->{features} = [ split(/\s+/, $1) ];
- /^Target-Description:/ and $target->{desc} = get_multiline();
+ /^Target-Depends:\s*(.+)\s*$/ and $target->{depends} = [ split(/\s+/, $1) ];
+ /^Target-Description:/ and $target->{desc} = get_multiline(*FILE);
/^Linux-Version:\s*(.+)\s*$/ and $target->{version} = $1;
/^Linux-Release:\s*(.+)\s*$/ and $target->{release} = $1;
/^Linux-Kernel-Arch:\s*(.+)\s*$/ and $target->{karch} = $1;
};
/^Target-Profile-Name:\s*(.+)\s*$/ and $profile->{name} = $1;
/^Target-Profile-Packages:\s*(.*)\s*$/ and $profile->{packages} = [ split(/\s+/, $1) ];
- /^Target-Profile-Description:\s*(.*)\s*/ and $profile->{desc} = get_multiline();
- /^Target-Profile-Config:/ and $profile->{config} = get_multiline("\t");
+ /^Target-Profile-Description:\s*(.*)\s*/ and $profile->{desc} = get_multiline(*FILE);
+ /^Target-Profile-Config:/ and $profile->{config} = get_multiline(*FILE, "\t");
/^Target-Profile-Kconfig:/ and $profile->{kconfig} = 1;
}
+ close FILE;
foreach my $target (@target) {
@{$target->{profiles}} > 0 or $target->{profiles} = [
{
return @target;
}
-sub parse_package_metadata() {
- my $pkg;
- my $makefile;
- my $preconfig;
- my $subdir;
- my $src;
- while (<>) {
- chomp;
- /^Source-Makefile: \s*((.+\/)([^\/]+)\/Makefile)\s*$/ and do {
- $makefile = $1;
- $subdir = $2;
- $src = $3;
- $subdir =~ s/^package\///;
- $subdir{$src} = $subdir;
- $srcpackage{$src} = [];
- undef $pkg;
- };
- /^Package:\s*(.+?)\s*$/ and do {
- $pkg = {};
- $pkg->{src} = $src;
- $pkg->{makefile} = $makefile;
- $pkg->{name} = $1;
- $pkg->{default} = "m if ALL";
- $pkg->{depends} = [];
- $pkg->{builddepends} = [];
- $pkg->{subdir} = $subdir;
- $package{$1} = $pkg;
- push @{$srcpackage{$src}}, $pkg;
- };
- /^Version: \s*(.+)\s*$/ and $pkg->{version} = $1;
- /^Title: \s*(.+)\s*$/ and $pkg->{title} = $1;
- /^Menu: \s*(.+)\s*$/ and $pkg->{menu} = $1;
- /^Submenu: \s*(.+)\s*$/ and $pkg->{submenu} = $1;
- /^Submenu-Depends: \s*(.+)\s*$/ and $pkg->{submenudep} = $1;
- /^Default: \s*(.+)\s*$/ and $pkg->{default} = $1;
- /^Provides: \s*(.+)\s*$/ and do {
- my @vpkg = split /\s+/, $1;
- foreach my $vpkg (@vpkg) {
- $package{$vpkg} or $package{$vpkg} = { vdepends => [] };
- push @{$package{$vpkg}->{vdepends}}, $pkg->{name};
- }
- };
- /^Depends: \s*(.+)\s*$/ and $pkg->{depends} = [ split /\s+/, $1 ];
- /^Build-Depends: \s*(.+)\s*$/ and $pkg->{builddepends} = [ split /\s+/, $1 ];
- /^Category: \s*(.+)\s*$/ and do {
- $pkg->{category} = $1;
- defined $category{$1} or $category{$1} = {};
- defined $category{$1}->{$src} or $category{$1}->{$src} = [];
- push @{$category{$1}->{$src}}, $pkg;
- };
- /^Description: \s*(.*)\s*$/ and $pkg->{description} = "\t\t $1\n". get_multiline("\t\t ");
- /^Config: \s*(.*)\s*$/ and $pkg->{config} = "$1\n".get_multiline();
- /^Prereq-Check:/ and $pkg->{prereq} = 1;
- /^Preconfig:\s*(.+)\s*$/ and do {
- my $pkgname = $pkg->{name};
- $preconfig{$pkgname} or $preconfig{$pkgname} = [];
- $preconfig = {
- id => $1
- };
- push @{$preconfig{$pkgname}}, $preconfig;
- };
- /^Preconfig-Type:\s*(.*?)\s*$/ and $preconfig->{type} = $1;
- /^Preconfig-Label:\s*(.*?)\s*$/ and $preconfig->{label} = $1;
- /^Preconfig-Default:\s*(.*?)\s*$/ and $preconfig->{default} = $1;
- }
- return %category;
-}
-
sub gen_kconfig_overrides() {
my %config;
my %kconfig;
undef $help;
}
- print <<EOF
+ print <<EOF;
config TARGET_$target->{conf}
bool "$target->{name}"
select $target->{arch}
select LINUX_$kernel
-$features$help
-
EOF
+ if ($target->{id} ne $target->{board}) {
+ print "\tselect TARGET_".$target->{boardconf}."\n";
+ }
+ foreach my $dep (@{$target->{depends}}) {
+ my $mode = "depends";
+ my $flags;
+ my $name;
+
+ $dep =~ /^([@\+\-]+)(.+)$/;
+ $flags = $1;
+ $name = $2;
+
+ $flags =~ /-/ and $mode = "deselect";
+ $flags =~ /\+/ and $mode = "select";
+ $flags =~ /@/ and print "\t$mode $name\n";
+ }
+
+ print "$features$help\n\n"
}
print <<EOF;
foreach my $target (@target) {
print "\t\tdefault \"".$target->{board}."\" if TARGET_".$target->{conf}."\n";
}
+
+ # add hidden target config options
+ foreach my $target (@target) {
+ next if $board{$target->{board}};
+ if ($target->{id} ne $target->{board}) {
+ print "\nconfig TARGET_".$target->{boardconf}."\n\tbool\n";
+ $board{$target->{board}} = 1;
+ }
+ }
print <<EOF;
choice
print "endchoice\n";
}
-
-sub find_package_dep($$) {
+my %dep_check;
+sub __find_package_dep($$) {
my $pkg = shift;
my $name = shift;
my $deps = ($pkg->{vdepends} or $pkg->{depends});
return 0 unless defined $deps;
foreach my $dep (@{$deps}) {
+ next if $dep_check{$dep};
+ $dep_check{$dep} = 1;
return 1 if $dep eq $name;
- return 1 if ($package{$dep} and (find_package_dep($package{$dep},$name) == 1));
+ return 1 if ($package{$dep} and (__find_package_dep($package{$dep},$name) == 1));
}
return 0;
}
+# wrapper to avoid infinite recursion
+sub find_package_dep($$) {
+ my $pkg = shift;
+ my $name = shift;
+
+ %dep_check = ();
+ return __find_package_dep($pkg, $name);
+}
+
sub package_depends($$) {
my $a = shift;
my $b = shift;
my $depends = shift;
my $only_dep = shift;
my $res;
+ my $dep = shift;
+ $dep or $dep = {};
$depends or return;
my @depends = @$depends;
# thus if FOO depends on other config options, these dependencies
# will not be checked. To fix this, we simply emit all of FOO's
# depends here as well.
- $package{$depend} and $res .= mconf_depends($package{$depend}->{depends}, 1);
+ $package{$depend} and mconf_depends($package{$depend}->{depends}, 1, $dep);
};
$flags =~ /@/ or $depend = "PACKAGE_$depend";
}
+ $dep->{$depend} =~ /select/ or $dep->{$depend} = $m;
+ }
+ foreach my $depend (keys %$dep) {
+ my $m = $dep->{$depend};
$res .= "\t\t$m $depend\n";
}
return $res;
print "\t";
$pkg->{menu} and print "menu";
print "config PACKAGE_".$pkg->{name}."\n";
- print "\t\ttristate \"$title\"\n";
+ print "\t\t".($pkg->{tristate} ? 'tristate' : 'bool')." \"$title\"\n";
print "\t\tdefault y if DEFAULT_".$pkg->{name}."\n";
foreach my $default (split /\s*,\s*/, $pkg->{default}) {
print "\t\tdefault $default\n";
}
sub gen_package_config() {
- parse_package_metadata();
+ parse_package_metadata($ARGV[0]) or exit 1;
print "menuconfig UCI_PRECONFIG\n\tbool \"Image configuration\"\n";
foreach my $preconfig (keys %preconfig) {
- foreach my $cfg (@{$preconfig{$preconfig}}) {
- my $conf = $cfg->{id};
+ foreach my $cfg (keys %{$preconfig{$preconfig}}) {
+ my $conf = $preconfig{$preconfig}->{$cfg}->{id};
$conf =~ tr/\.-/__/;
print <<EOF
config UCI_PRECONFIG_$conf
- string "$cfg->{label}" if UCI_PRECONFIG
+ string "$preconfig{$preconfig}->{$cfg}->{label}" if UCI_PRECONFIG
depends PACKAGE_$preconfig
- default "$cfg->{default}"
+ default "$preconfig{$preconfig}->{$cfg}->{default}"
EOF
}
my %dep;
my $line;
- parse_package_metadata();
+ parse_package_metadata($ARGV[0]) or exit 1;
foreach my $name (sort {uc($a) cmp uc($b)} keys %package) {
my $config;
my $pkg = $package{$name};
}
foreach my $preconfig (keys %preconfig) {
my $cmds;
- foreach my $cfg (@{$preconfig{$preconfig}}) {
- my $conf = $cfg->{id};
+ foreach my $cfg (keys %{$preconfig{$preconfig}}) {
+ my $conf = $preconfig{$preconfig}->{$cfg}->{id};
$conf =~ tr/\.-/__/;
- $cmds .= "\techo \"uci set '$cfg->{id}=\$(subst \",,\$(CONFIG_UCI_PRECONFIG_$conf))'\"; \\\n";
+ $cmds .= "\techo \"uci set '$preconfig{$preconfig}->{$cfg}->{id}=\$(subst \",,\$(CONFIG_UCI_PRECONFIG_$conf))'\"; \\\n";
}
next unless $cmds;
print <<EOF